			lcd_output equ P1
			rs equ P3.5 
			r_w equ P3.6
			e equ P3.7
			temp equ 0feh
;***************************************
;ports used for i2c communication
;***************************************
			sda equ P3.3
			scl equ P3.4			
;****************************************
;***************************************
			org 30h
		acall display_setup
			mov r5,#08h 
			acall startc
			
			mov a,#10100000b	; write command
			acall send	
			acall ack
			mov a,#06h	;memory address
			acall send
			acall ack
			mov a,#00h	;value
			acall send
			acall ack
			mov a,#01h	;value
			acall send
			acall ack
			mov a,#02h	;value
			acall send
			acall ack
			mov a,#03h	;value
			acall send
			acall ack
			mov a,#04h	;value
			acall send
			acall ack
			mov a,#05h	;value
			acall send
			acall ack
			mov a,#06h	;value
			acall send
			acall ack
			mov a,#07h	;value
			acall send
			acall ack
			
			acall stop
			
			acall delay1
			acall delay1
			acall delay1
			acall delay1
			acall startc
			
			mov a,#10100000b	; write command
			acall send	;device address
			acall ack
			mov a,#06h	;memory address
			acall send
			acall ack
			acall startc
			acall ack
			mov a,#10100001b	
			acall send	
			acall ack
			
l4:			acall recv
			
			
			
			mov r0,#temp
			orl a,#30h   
			mov @r0,a

			
			acall display
			
			djnz r5,l3
			acall nak
			sjmp l5
l3:			acall ack
			sjmp l4
l5:			acall stop
here:		sjmp here
;---command--------------------------------------------------------------------------
command:								
			mov lcd_output,a ;copy reg a to port 1
			clr rs ;rs=0 for command
			clr r_w ;r/w=0 for write
			setb e ;e=1 for high pulse
			acall delay1;give lcd some time
			clr e ;e=0 for h-to-l pulse
			ret
;---data_display----------------------------------------------------------------------------
data_display:							
			mov lcd_output,a ;copy reg a to port 1
			setb rs ;rs=1 for data
			clr r_w ;r/w=0 for write
			setb e ;e=1 for high pulse
			acall delay1 ;give lcd some time
			clr e ;e=0 for h-to-l pulse
			ret	
;---display_setup-----------------------------------------------------------------------
display_setup:
			mov a,#38h 								 ;init. lcd 2 lines ,5x7 matrix
			lcall command							 ;issue command
			mov a,#0ch 								 ;lcd on, cursor off
			lcall command 							 ;issue command
			mov a,#01h 								 ;clear lcd command
			lcall command											;issue command
			ret
;---address----------------------------------------------------------
display:						
			mov r0,#temp
			mov a,@r0
		
			lcall data_display
			ret
;---delay_for_busy_flag-------------------------------------------
delay1:		 mov r7,#0ffh
delay_3:	 mov r6,#0ffh
delay_4:	 djnz r6,delay_4
			djnz r7,delay_3
			ret
		


 
;****************************************
;start condition for i2c communication
;****************************************
startc:		setb scl
			setb sda
			nop
			nop
			clr sda
			
			ret

;*****************************************
;stop condition for i2c bus
;*****************************************
			stop:
			
			clr sda
			setb scl
			nop
			nop
			setb sda
			
			ret
 
;*****************************************
;sending data to slave on i2c bus
;*****************************************
send:		mov r7,#08h
back:		rlc a
			
			clr scl
			nop
			nop
			nop
			mov sda,c
			setb scl
			nop
			nop
			nop
			djnz r7,back
			clr scl
			
			ret

 
;*****************************************
;ack and nak for i2c bus
;*****************************************
ack:
			clr sda
			setb scl
			clr scl
			setb sda
			ret
 
nak:		
			setb sda
			nop
			nop
			setb scl
			nop
			nop
			nop
			clr scl
			;setb scl
			ret
 
;*****************************************
;receiving data from slave on i2c bus
;*****************************************
recv:	mov r7,#08h
back2:	clr scl
		
		nop
		nop
		nop
		mov c,sda
		setb scl
		nop
		nop
		nop
		rlc a
		djnz r7,back2
		clr scl
		ret
		

		delay:
		mov r7,#4h
here1:	djnz r7,here1
		ret
		end
